%S Code
%{
static char * sccsid = "@(#)latex2pl.l	1.2 3/1/91 14:36:52";
char tempstr[500];
int in_verbatim;
int codelines, lines;
%}

%%
"\\begin{prolog}"	{ BEGIN Code; in_verbatim = 1; codelines = 0; }
"\\begin{code}"		{ BEGIN Code; }

<Code>\"[^"\n]*		{
			 if (yytext[yyleng-1] == '\\') yymore();
			 else {
				doublepercent(yytext,tempstr);
				printf(tempstr);
			 }
			}

<Code>\"		printf(yytext);

<Code>"\\end{code}"	BEGIN 0;
<Code>"\\end{prolog}"	{BEGIN 0; in_verbatim = 0;}

<Code>"%"		printf("%%"); /* Hard to print out, eh? */
<Code>.			printf(yytext);
<Code>\n		{ printf(yytext);
			  lines++;
			  if (in_verbatim) codelines++;
/*	if (codelines == 39)
	  fprintf(stderr,
	   "Warning: code chunk may be too large for LaTeX (line %d)\n",lines);
*/
			}

.			;
\n			lines++;
%%

#undef BEGIN
#include "newio.h"
#include <string.h>

PROC VOID print_help();	/* Forward reference for type declaration */
PROC STRING assure_suffix();
PROC STRING remove_suffix();
PROC BOOL is_a_suffix();

PROC VOID main(argc, argv)
INT argc;
STRING argv[];
BEGIN
    STRING file_basename, input_file, output_file;

    WHILE DECR argc	/* process the command line */
    DO  IF (CONT CONT INCR argv) == '-'
	THEN SWITCH CONT INCR CONT argv	/* process command line flags */
	    IN  CASE 'h':
		print_help();
		exit(0);
		BREAK;
	    DEFAULT:
		fprintf(stderr, "(latex2pl.l): unknown flag %s\n", CONT argv);
		exit(1)
	    NI
	ELSE	/* non-flag command-line arguments  */
			    /* open the file specified on the command line */
	    file_basename = remove_suffix(CONT argv, ".tex");
	    input_file = assure_suffix(CONT argv, ".tex");
	    Freopen(input_file,"r",stdin);
	    output_file = assure_suffix(file_basename, ".pl");
	    Freopen(output_file,"w",stdout);
	FI
    OD
    yylex();
END

PROC VOID doublepercent(str,newstr)
STRING str, newstr;
BEGIN
    WHILE CONT newstr INCR = CONT str
    DO
	IF CONT str == '%'
	THEN CONT newstr INCR = '%'
	FI
	str INCR
    OD
END

/*****************************************************************************\
    remove_suffix: removes the suffix from a copy of the string.
	If the string does not have the suffix, then the original string is
	returned.
\*****************************************************************************/

PROC STRING remove_suffix(string, suffix)
STRING string, suffix;
BEGIN
    INT str_len, suffix_len;
    STRING result;

    str_len = strlen(string);
    suffix_len = strlen(suffix);

    IF str_len >= suffix_len
    ANDIF is_a_suffix(suffix, string)
    THEN
	result = MALLOC(CHAR, str_len-suffix_len,
		    "remove_suffix", "string");
	strncpy(result, string, str_len-suffix_len);
	CONT(result+str_len) = '\0';
	RETURN result
    ELSE RETURN string
    FI
END

PROC BOOL is_a_suffix(suffix, string)
STRING suffix, string;
BEGIN
    INT str_len, suffix_len;

    str_len = strlen(string);
    suffix_len = strlen(suffix);
    IF suffix_len > str_len
    THEN RETURN FALSE
    ELIF strcmp(string+str_len-suffix_len, suffix) == 0
    THEN RETURN TRUE
    ELSE RETURN FALSE
    FI
END

PROC STRING assure_suffix(file_name, suffix)
STRING file_name, suffix;
BEGIN
    INT str_len, suffix_len, sub;
    STRING result;

    str_len = strlen(file_name);
    suffix_len = strlen(suffix);

    IF (sub = substr(file_name, suffix)) != -1
    ANDIF str_len == suffix_len+sub
    THEN	/* return the name untouched if it ends in the suffix */
	RETURN file_name
    ELSE	/* Append .tex to a copy of the file_name */
	result = MALLOC(CHAR, (str_len=strlen(file_name))+strlen(suffix)+1,
		    "assure_suffix", "file name");
	strcpy(result, file_name);
	strcpy(result+str_len, suffix);
	RETURN result
    FI
END

/*****************************************************************************\
    substr: return the index (0-based) of "substring" in "string".
    If none, return -1.
    E.g. substr("foo.tex", ".tex") == 3
	 substr("foo.tex", "")     == 0
\*****************************************************************************/

PROC INT substr(str, substring)
STRING str, substring;
BEGIN
    STRING mptr,	/* pointer into the main string */
	tmptr,		/* temporary pointer into the main string */
	tsptr;		/* temporary pointer into the substring */
    BOOL match, found;
    
    /* The outer pointer (mptr) traverses "str" one character at a time,
	testing for the presence of the substring.
	This loop continues until the end of the "str" is reached
	or a match has been found.
     */
    FOR mptr = str, found = FALSE
    AS CONT mptr != '\0' ANDIF NOT found
    EXEC mptr INCR
    DO
	/* The inner loop does the actual character checking.
	    The loop terminates if the end of either string is reached or a
	    mismatch is encountered.
	 */
	FOR tmptr = mptr, tsptr = substring, match = TRUE
	AS CONT tmptr ANDIF CONT tsptr ANDIF match
	EXEC tmptr INCR, tsptr INCR
	DO match &= CONT tmptr == CONT tsptr
	OD
	IF match
	THEN RETURN mptr-str
	FI
    OD
    RETURN -1
END

STRING Help[] = {
    "latex2pl: extracts a prolog file from a LaTeX document",
    "    usage:",
    "\tlatex2pl foo",
    "    which is equivalent to",
    "\tlatex2pl < foo.tex > foo.pl"
    };

PROC VOID print_help()
BEGIN
#define NUM_HELP_LINES (sizeof(Help)/sizeof(*Help))
    INT i;
    STRING REF tptr;

    FOR i=0, tptr = Help AS i < NUM_HELP_LINES EXEC i INCR, tptr INCR
    DO
	fprintf(stderr, "%s\n", CONT tptr)
    OD
END
